/* cmain.c - Startup code for the PowerPC.  */
/*
 *  GRUB  --  GRand Unified Bootloader
 *  Copyright (C) 2003, 2004, 2005  Free Software Foundation, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdint.h>

#include "ieee1275.h"
#include "multiboot.h"

static char message[] = "Hello, world.\n";

void
cmain (uint32_t r3, uint32_t r4, uint32_t r5)
{
  grub_ieee1275_phandle_t chosen;
  grub_ieee1275_ihandle_t stdout;

  grub_ieee1275_entry_fn = (intptr_t (*)(void *)) r5;

  grub_ieee1275_finddevice ("/chosen", &chosen);
  grub_ieee1275_get_property (chosen, "stdout", &stdout, sizeof stdout, 0);

  grub_ieee1275_write (stdout, message, sizeof message, 0);
}
